##parameters=pystr=None
# $Id: encodeJsString.py,v 1.2 2005/03/03 13:58:20 fermigier Exp $
"""
Encode a python string into a javascript string

This is very usefull to set js variable like
 <script type="text/javascript"
  tal:define="js_value python:here.encodeJsString(value)"
  tal:content='structure string:
  <!--
      var value = "${js_value}";
  //--> />
"""

if not pystr:
    return ''

quotes = (("\\", "\\\\"),
          ("\n", "\\n"),
          ("\r", "\\r"),
          ("'", "\\'"),
          ('"', '\\"'))

jsstr = pystr
for item in quotes:
    jsstr = jsstr.replace(item[0], item[1])

return jsstr
